Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs	(revision 13611)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/BinPacking2D.cs	(revision 13612)
@@ -37,5 +37,4 @@
     public BinPacking2D(RectangularPackingBin binMeasures)
       : base(binMeasures) {
-      //ExtremePoints = new HashSet<TwoDimensionalPacking>();
       ExtremePoints = new SortedSet<TwoDimensionalPacking>(new EPComparer2D());
       ExtremePoints.Add(binMeasures.Origin);
@@ -50,5 +49,5 @@
       return new BinPacking2D(this, cloner);
     }
-                      
+
     protected override void GenerateNewExtremePointsForNewItem(RectangularPackingItem newItem, TwoDimensionalPacking position) {
 
@@ -73,5 +72,5 @@
       if (sourcePointY.X < BinMeasures.Width && sourcePointY.Y < BinMeasures.Height) {
         //Traversing down the x-axis  
-        while (sourcePointY.X > 0 && !IsPointOccupied(new TwoDimensionalPacking (0,sourcePointY.X - 1, sourcePointY.Y))) {
+        while (sourcePointY.X > 0 && !IsPointOccupied(new TwoDimensionalPacking(0, sourcePointY.X - 1, sourcePointY.Y))) {
           sourcePointY.X--;
         }
@@ -111,8 +110,8 @@
         || IsPositionFeasible(measures, TwoDimensionalPacking.MoveDown(currentPosition))) {
         //Slide the item as far as possible to the bottom
-          while (IsPositionFeasible(measures, TwoDimensionalPacking.MoveDown(currentPosition))) {
-            currentPosition = TwoDimensionalPacking.MoveDown(currentPosition);
-        }
-          if (IsPositionFeasible(measures, TwoDimensionalPacking.MoveLeft(currentPosition)))
+        while (IsPositionFeasible(measures, TwoDimensionalPacking.MoveDown(currentPosition))) {
+          currentPosition = TwoDimensionalPacking.MoveDown(currentPosition);
+        }
+        if (IsPositionFeasible(measures, TwoDimensionalPacking.MoveLeft(currentPosition)))
           currentPosition = TwoDimensionalPacking.MoveLeft(currentPosition);
       }
@@ -120,5 +119,5 @@
       return IsPositionFeasible(measures, currentPosition) ? currentPosition : null;
     }
-    
+
     public override void SlidingBasedPacking(ref List<int> sequence, ItemList<RectangularPackingItem> itemMeasures) {
       var temp = new List<int>(sequence);
@@ -193,5 +192,5 @@
 
     protected override void InitializeOccupationLayers() {
-      for (int i = 0; i*10 <= BinMeasures.Width; i += 1 ) {
+      for (int i = 0; i * 10 <= BinMeasures.Width; i += 1) {
         OccupationLayers[i] = new List<int>();
       }
@@ -207,6 +206,6 @@
       return OccupationLayers[position.X / 10];
     }
-    protected override List<int> GetLayerItemIDs(RectangularPackingItem measures, TwoDimensionalPacking position) { 
-      List<int> result = new List<int> ();
+    protected override List<int> GetLayerItemIDs(RectangularPackingItem measures, TwoDimensionalPacking position) {
+      List<int> result = new List<int>();
       int x1 = position.X / 10;
       int x2 = (position.X + (position.Rotated ? measures.Height : measures.Width)) / 10;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs	(revision 13611)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/BinPacking3D.cs	(revision 13612)
@@ -36,5 +36,4 @@
     public BinPacking3D(CuboidPackingBin binMeasures)
       : base(binMeasures) {
-      //ExtremePoints = new HashSet<ThreeDimensionalPacking>();
       ExtremePoints = new SortedSet<ThreeDimensionalPacking>(new EPComparer3D());
       ExtremePoints.Add(binMeasures.Origin);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 13611)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/HeuristicLab.Problems.BinPacking.Views-3.3.csproj	(revision 13612)
@@ -173,4 +173,12 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.BinPacking.2D\3.3\HeuristicLab.Problems.BinPacking2D-3.3.csproj">
+      <Project>{56dd7f51-3164-4c26-a97a-add6fe4b4e86}</Project>
+      <Name>HeuristicLab.Problems.BinPacking2D-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.BinPacking.3D\3.3\HeuristicLab.Problems.BinPacking3D-3.3.csproj">
+      <Project>{95680c63-1e06-4e66-b33b-272a772321c7}</Project>
+      <Name>HeuristicLab.Problems.BinPacking3D-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.BinPacking\3.3\HeuristicLab.Problems.BinPacking-3.3.csproj">
       <Project>{F8A55094-3CD5-4034-B0CA-5BD7FFB016D4}</Project>
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan2DView.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan2DView.cs	(revision 13611)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/PackingPlan2DView.cs	(revision 13612)
@@ -24,7 +24,4 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.Encodings.PackingEncoding.PackingPlan;
-using HeuristicLab.Problems.BinPacking.PackingItem;
-using HeuristicLab.Problems.BinPacking.PackingBin;
-using HeuristicLab.Problems.BinPacking.Dimensions;
 
 namespace HeuristicLab.Problems.BinPacking.Views {